Unit SearchComboBox;

{$MODE ObjFPC}{$H+}

Interface

Uses
  Classes, SysUtils, LResources, Forms, Controls, Graphics, Dialogs, StdCtrls;

Type

  { TSearchComboBox }

  TSearchComboBox = Class(TComboBox)
  private

  protected
    Procedure KeyPress(Var Key: Char); override;
  public
    Constructor Create(TheOwner: TComponent); override;
  published

  End;

Procedure Register;

Implementation

Procedure Register;
Begin
{$I searchcombobox_icon.lrs}
  RegisterComponents('Standard', [TSearchComboBox]);
End;

{ TSearchComboBox }

Procedure TSearchComboBox.KeyPress(Var Key: Char);
Var
  i: integer;
  s: String;
Begin
  Inherited;
  If Key = #8 Then Begin
    If (SelStart > 1) Then Begin
      SelStart := SelStart - 1
    End
    Else Begin
      If SelLength > 1 Then Begin
        Text := '';
        Change;
        Key := #0;
        exit;
      End;
    End;
    s := copy(Text, 1, SelStart);
  End
  Else Begin
    s := copy(Text, 1, SelStart) + Key;
  End;
  For i := 0 To Items.Count - 1 Do Begin
    If pos(LowerCase(s), LowerCase(Items[i])) <> 0 Then Begin
      Text := Items[i];
      SelStart := Length(s);
      SelLength := Length(Text) - Length(s);
      Change;
      Key := #0;
      Break;
    End;
  End;
End;

Constructor TSearchComboBox.Create(TheOwner: TComponent);
Begin
  Inherited Create(TheOwner);
  AutoDropDown := true;
End;

End.

